## Instructions

Select the test group to run by setting the `PREDICTMD_TEST_GROUP` environment variable before running the test suite.

For example, to run the `all` test group, you would run the following lines in Julia:
```julia
ENV["PREDICTMD_TEST_GROUP"] = "all"
import Pkg
Pkg.test("PredictMD")
Pkg.test("PredictMDExtra")
Pkg.test("PredictMDFull")
```

## Available test groups

| group | default | all | test-plots | import-only | travis-1 | travis-2 | travis-3 | travis-4 | travis-5 | travis-6 | travis-7 |
| :--- | :--- | :--- | :--- | :--- | :--- | :--- | :--- | :--- | :--- | :--- | :--- |
| Import package | <a href="#available-test-groups"><img alt="YES" title="YES" src="https://via.placeholder.com/40x40/00ff00/000000.png?text=+"></a> | <a href="#available-test-groups"><img alt="YES" title="YES" src="https://via.placeholder.com/40x40/00ff00/000000.png?text=+"></a> | <a href="#available-test-groups"><img alt="YES" title="YES" src="https://via.placeholder.com/40x40/00ff00/000000.png?text=+"></a> | <a href="#available-test-groups"><img alt="YES" title="YES" src="https://via.placeholder.com/40x40/00ff00/000000.png?text=+"></a> | <a href="#available-test-groups"><img alt="YES" title="YES" src="https://via.placeholder.com/40x40/00ff00/000000.png?text=+"></a> | <a href="#available-test-groups"><img alt="YES" title="YES" src="https://via.placeholder.com/40x40/00ff00/000000.png?text=+"></a> | <a href="#available-test-groups"><img alt="YES" title="YES" src="https://via.placeholder.com/40x40/00ff00/000000.png?text=+"></a> | <a href="#available-test-groups"><img alt="YES" title="YES" src="https://via.placeholder.com/40x40/00ff00/000000.png?text=+"></a> | <a href="#available-test-groups"><img alt="YES" title="YES" src="https://via.placeholder.com/40x40/00ff00/000000.png?text=+"></a> | <a href="#available-test-groups"><img alt="YES" title="YES" src="https://via.placeholder.com/40x40/00ff00/000000.png?text=+"></a> | <a href="#available-test-groups"><img alt="YES" title="YES" src="https://via.placeholder.com/40x40/00ff00/000000.png?text=+"></a> |
| Unit tests | <a href="#available-test-groups"><img alt="YES" title="YES" src="https://via.placeholder.com/40x40/00ff00/000000.png?text=+"></a> | <a href="#available-test-groups"><img alt="YES" title="YES" src="https://via.placeholder.com/40x40/00ff00/000000.png?text=+"></a> | <a href="#available-test-groups"><img alt="YES" title="YES" src="https://via.placeholder.com/40x40/00ff00/000000.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> | <a href="#available-test-groups"><img alt="YES" title="YES" src="https://via.placeholder.com/40x40/00ff00/000000.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> |
| Integration tests (1/7) | <a href="#available-test-groups"><img alt="YES" title="YES" src="https://via.placeholder.com/40x40/00ff00/000000.png?text=+"></a> | <a href="#available-test-groups"><img alt="YES" title="YES" src="https://via.placeholder.com/40x40/00ff00/000000.png?text=+"></a> | <a href="#available-test-groups"><img alt="YES" title="YES" src="https://via.placeholder.com/40x40/00ff00/000000.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> | <a href="#available-test-groups"><img alt="YES" title="YES" src="https://via.placeholder.com/40x40/00ff00/000000.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> |
| Integration tests (2/7) | <a href="#available-test-groups"><img alt="YES" title="YES" src="https://via.placeholder.com/40x40/00ff00/000000.png?text=+"></a> | <a href="#available-test-groups"><img alt="YES" title="YES" src="https://via.placeholder.com/40x40/00ff00/000000.png?text=+"></a> | <a href="#available-test-groups"><img alt="YES" title="YES" src="https://via.placeholder.com/40x40/00ff00/000000.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> | <a href="#available-test-groups"><img alt="YES" title="YES" src="https://via.placeholder.com/40x40/00ff00/000000.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> |
| Integration tests (3/7) | <a href="#available-test-groups"><img alt="YES" title="YES" src="https://via.placeholder.com/40x40/00ff00/000000.png?text=+"></a> | <a href="#available-test-groups"><img alt="YES" title="YES" src="https://via.placeholder.com/40x40/00ff00/000000.png?text=+"></a> | <a href="#available-test-groups"><img alt="YES" title="YES" src="https://via.placeholder.com/40x40/00ff00/000000.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> | <a href="#available-test-groups"><img alt="YES" title="YES" src="https://via.placeholder.com/40x40/00ff00/000000.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> |
| Integration tests (4/7) | <a href="#available-test-groups"><img alt="YES" title="YES" src="https://via.placeholder.com/40x40/00ff00/000000.png?text=+"></a> | <a href="#available-test-groups"><img alt="YES" title="YES" src="https://via.placeholder.com/40x40/00ff00/000000.png?text=+"></a> | <a href="#available-test-groups"><img alt="YES" title="YES" src="https://via.placeholder.com/40x40/00ff00/000000.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> | <a href="#available-test-groups"><img alt="YES" title="YES" src="https://via.placeholder.com/40x40/00ff00/000000.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> |
| Integration tests (5/7) | <a href="#available-test-groups"><img alt="YES" title="YES" src="https://via.placeholder.com/40x40/00ff00/000000.png?text=+"></a> | <a href="#available-test-groups"><img alt="YES" title="YES" src="https://via.placeholder.com/40x40/00ff00/000000.png?text=+"></a> | <a href="#available-test-groups"><img alt="YES" title="YES" src="https://via.placeholder.com/40x40/00ff00/000000.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> | <a href="#available-test-groups"><img alt="YES" title="YES" src="https://via.placeholder.com/40x40/00ff00/000000.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> |
| Integration tests (6/7) | <a href="#available-test-groups"><img alt="YES" title="YES" src="https://via.placeholder.com/40x40/00ff00/000000.png?text=+"></a> | <a href="#available-test-groups"><img alt="YES" title="YES" src="https://via.placeholder.com/40x40/00ff00/000000.png?text=+"></a> | <a href="#available-test-groups"><img alt="YES" title="YES" src="https://via.placeholder.com/40x40/00ff00/000000.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> | <a href="#available-test-groups"><img alt="YES" title="YES" src="https://via.placeholder.com/40x40/00ff00/000000.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> |
| Integration tests (7/7) | <a href="#available-test-groups"><img alt="YES" title="YES" src="https://via.placeholder.com/40x40/00ff00/000000.png?text=+"></a> | <a href="#available-test-groups"><img alt="YES" title="YES" src="https://via.placeholder.com/40x40/00ff00/000000.png?text=+"></a> | <a href="#available-test-groups"><img alt="YES" title="YES" src="https://via.placeholder.com/40x40/00ff00/000000.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> | <a href="#available-test-groups"><img alt="YES" title="YES" src="https://via.placeholder.com/40x40/00ff00/000000.png?text=+"></a> |
| Test plots | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> | <a href="#available-test-groups"><img alt="YES" title="YES" src="https://via.placeholder.com/40x40/00ff00/000000.png?text=+"></a> | <a href="#available-test-groups"><img alt="YES" title="YES" src="https://via.placeholder.com/40x40/00ff00/000000.png?text=+"></a> | <a href="#available-test-groups"><img alt="NO" title="NO" src="https://via.placeholder.com/40x40/ff0000/ffffff.png?text=+"></a> | <a href="#available-test-groups"><img alt="YES" title="YES" src="https://via.placeholder.com/40x40/00ff00/000000.png?text=+"></a> | <a href="#available-test-groups"><img alt="YES" title="YES" src="https://via.placeholder.com/40x40/00ff00/000000.png?text=+"></a> | <a href="#available-test-groups"><img alt="YES" title="YES" src="https://via.placeholder.com/40x40/00ff00/000000.png?text=+"></a> | <a href="#available-test-groups"><img alt="YES" title="YES" src="https://via.placeholder.com/40x40/00ff00/000000.png?text=+"></a> | <a href="#available-test-groups"><img alt="YES" title="YES" src="https://via.placeholder.com/40x40/00ff00/000000.png?text=+"></a> | <a href="#available-test-groups"><img alt="YES" title="YES" src="https://via.placeholder.com/40x40/00ff00/000000.png?text=+"></a> | <a href="#available-test-groups"><img alt="YES" title="YES" src="https://via.placeholder.com/40x40/00ff00/000000.png?text=+"></a> |
